/*
Part of KSudoku project
http://ksudoku.sf.net
(c) 2005 Francesco Rossi <redsh@email.it>
(c) 2007 Johannes Bergmeier <Johannes.Bergmeier@gmx.net>
	 Mick Kappenburg <ksudoku@kappenburg.net>
	 Francesco Rossi <redsh@email.it>

This is free software released under GNU GENERAL PUBLIC LICENSE (GPLv2)
See COPYING file in project root directory for more information.

See the credits for this file in AUTHORS file in project root directory
*/
//
// C++ Interface: drawfactory
//

// Author:  <>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//

#ifndef KSUDOKUDRAWFACTORY_H
#define KSUDOKUDRAWFACTORY_H

#include "drawbase.h"

namespace ksudoku {


/**
 * Generate Draw instances
 */
class DrawFactory{
public:
	DrawFactory();
	~DrawFactory();

	///@return  Draw instance for puzzle, or 0 on error
	///@warning caller is responsible for deletion
	DrawBase* create_instance(Puzzle const& puzzle, Symbols const& symbols) const;
};

}

#endif
